<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>iPcRules Struct Reference (CEL: Crystal Entity Layer 2.0 Public API Reference)</title>
<link href="tabs.css" rel="stylesheet" type="text/css">
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<table border="0" cellpadding="0" cellspacing="0" width="100%" class="head">
 <tr height="59">
  <td class="head" width="202" valign="bottom" style="padding-left:0;"><a href="http://cel.crystalspace3d.org/"><img src="celblur.png" width="210" height="59" alt="CEL" border="0"></a></td>
  <td class="head"><h2>Public API Reference</h2></td>
 </tr>
 <tr height="11">
  <td colspan="2" class="headshadow" valign="top" style="padding-left:0;"><img src="celshadow.png" width="9" height="11" alt="" border="0"></td>
 </tr>
</table>
<div class="content">
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="hierarchy.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a>  </div>
  <div class="headertitle">
<div class="title">iPcRules Struct Reference</div>  </div>
</div><!--header-->
<div class="contents">
<!-- doxytag: class="iPcRules" --><!-- doxytag: inherits="iBase" -->
<p>This property class represents a set of active rules for an entity.  
 <a href="structiPcRules.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="rules_8h_source.html">propclass/rules.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for iPcRules:</div>
<div class="dyncontent">
 <div class="center">
  <img src="structiPcRules.png" usemap="#iPcRules_map" alt=""/>
  <map id="iPcRules_map" name="iPcRules_map">
<area doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html" alt="iBase" shape="rect" coords="0,0,61,24"/>
</map>
 </div></div>

<p><a href="structiPcRules-members.html">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcRules.html#a89923097b616b94488007534c3497011">AddRule</a> (<a class="el" href="structiCelRule.html">iCelRule</a> *rule)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Add a rule.  <a href="#a89923097b616b94488007534c3497011"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcRules.html#ab5bd651e9e104eb91d7c5da61e55a6f0">AddRule</a> (<a class="el" href="structiCelRule.html">iCelRule</a> *rule, <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga28e82998c4c2d1197a1d412bba7da793">csTicks</a> time)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Add a rule which times out after a specific amount of time.  <a href="#ab5bd651e9e104eb91d7c5da61e55a6f0"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcRules.html#a2f7f5f16c2fdc9aec874541524cb12bf">DeleteAllRules</a> ()=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Delete all rules.  <a href="#a2f7f5f16c2fdc9aec874541524cb12bf"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcRules.html#a5e1c07ac2d4dffc12fb4bb4b75b042aa">DeleteRule</a> (<a class="el" href="structiCelRule.html">iCelRule</a> *rule)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Delete a rule.  <a href="#a5e1c07ac2d4dffc12fb4bb4b75b042aa"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcRules.html#a2d90d34a57eb949735c65231506dbc08">GetProperty</a> (const char *name, <a class="el" href="structcelData.html">celData</a> &amp;ret)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get a specific property.  <a href="#a2d90d34a57eb949735c65231506dbc08"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcRules.html#ad721cb91fe855ddcba36b078cabad4ce">GetPropertyBool</a> (const char *name)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get a specific property.  <a href="#ad721cb91fe855ddcba36b078cabad4ce"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcRules.html#ac489e0149af2f0e8e4cd03f919011861">GetPropertyColor</a> (const char *name, <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsColor.html">csColor</a> &amp;v)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get a specific property.  <a href="#ac489e0149af2f0e8e4cd03f919011861"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual float&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcRules.html#a79059bc158ff5168925f8b377af1aec0">GetPropertyFloat</a> (const char *name)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get a specific property.  <a href="#a79059bc158ff5168925f8b377af1aec0"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual long&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcRules.html#a8ced2bfc1d61946e47018d99b6bd203a">GetPropertyLong</a> (const char *name)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get a specific property.  <a href="#a8ced2bfc1d61946e47018d99b6bd203a"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual const char *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcRules.html#ae3b6571de348bcebdb9a394dc735b774">GetPropertyString</a> (const char *name)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get a specific property.  <a href="#ae3b6571de348bcebdb9a394dc735b774"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual celDataType&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcRules.html#a91217faf3dfd5936df82f32eb1c5eb0d">GetPropertyType</a> (const char *name)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the type of the property.  <a href="#a91217faf3dfd5936df82f32eb1c5eb0d"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcRules.html#a90c63a8378b8dd3bd6274ad03f7ffd90">GetPropertyVector</a> (const char *name, <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector2.html">csVector2</a> &amp;v)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get a specific property.  <a href="#a90c63a8378b8dd3bd6274ad03f7ffd90"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcRules.html#ab5ca106e2739e8593f8764f7a877e323">GetPropertyVector</a> (const char *name, <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a> &amp;v)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get a specific property.  <a href="#ab5ca106e2739e8593f8764f7a877e323"></a><br/></td></tr>
</table>
<hr/><a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><p>This property class represents a set of active rules for an entity. </p>
<p>It uses the rule base system (<a class="el" href="structiCelRuleBase.html" title="Interface for the Rule System.">iCelRuleBase</a>). Note that this property class will automatically load the rule base system if it is missing. When reading properties out of this pcrules it will check if there are any rules affecting the property. If not you will simply get the value from the associated 'pcproperties' property class (if present). Otherwise you will get a modified value according to the rules defined for this property (starting from the value out of pcproperties). If the 'pcproperties' is not present a default value is assumed (0 for numbers, empty string for string, 0-vector for vectors, and black for colors).</p>
<p>This property class can send out the following messages:</p>
<ul>
<li>'cel.rules.modifypar' (old 'pcrules_modifypar'): a parameter has been modified: parameters 'name' (name of the parameter).</li>
</ul>
<p>This property class supports the following actions (add prefix 'cel.rules.action.' if you want to access this action through a message):</p>
<ul>
<li>AddRule: parameters 'name' (string). Optional 'time' (long) parameter.</li>
<li>DeleteRule: parameters 'name' (string).</li>
<li>DeleteAllRules: no parameters. </li>
</ul>

<p>Definition at line <a class="el" href="rules_8h_source.html#l00050">50</a> of file <a class="el" href="rules_8h_source.html">rules.h</a>.</p>
</div><hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="a89923097b616b94488007534c3497011"></a><!-- doxytag: member="iPcRules::AddRule" ref="a89923097b616b94488007534c3497011" args="(iCelRule *rule)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcRules.html#a89923097b616b94488007534c3497011">iPcRules::AddRule</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structiCelRule.html">iCelRule</a> *&#160;</td>
          <td class="paramname"><em>rule</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Add a rule. </p>

</div>
</div>
<a class="anchor" id="ab5bd651e9e104eb91d7c5da61e55a6f0"></a><!-- doxytag: member="iPcRules::AddRule" ref="ab5bd651e9e104eb91d7c5da61e55a6f0" args="(iCelRule *rule, csTicks time)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcRules.html#a89923097b616b94488007534c3497011">iPcRules::AddRule</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structiCelRule.html">iCelRule</a> *&#160;</td>
          <td class="paramname"><em>rule</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga28e82998c4c2d1197a1d412bba7da793">csTicks</a>&#160;</td>
          <td class="paramname"><em>time</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Add a rule which times out after a specific amount of time. </p>

</div>
</div>
<a class="anchor" id="a2f7f5f16c2fdc9aec874541524cb12bf"></a><!-- doxytag: member="iPcRules::DeleteAllRules" ref="a2f7f5f16c2fdc9aec874541524cb12bf" args="()=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcRules.html#a2f7f5f16c2fdc9aec874541524cb12bf">iPcRules::DeleteAllRules</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Delete all rules. </p>

</div>
</div>
<a class="anchor" id="a5e1c07ac2d4dffc12fb4bb4b75b042aa"></a><!-- doxytag: member="iPcRules::DeleteRule" ref="a5e1c07ac2d4dffc12fb4bb4b75b042aa" args="(iCelRule *rule)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcRules.html#a5e1c07ac2d4dffc12fb4bb4b75b042aa">iPcRules::DeleteRule</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structiCelRule.html">iCelRule</a> *&#160;</td>
          <td class="paramname"><em>rule</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Delete a rule. </p>

</div>
</div>
<a class="anchor" id="a2d90d34a57eb949735c65231506dbc08"></a><!-- doxytag: member="iPcRules::GetProperty" ref="a2d90d34a57eb949735c65231506dbc08" args="(const char *name, celData &amp;ret)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="structiPcRules.html#a2d90d34a57eb949735c65231506dbc08">iPcRules::GetProperty</a> </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>name</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structcelData.html">celData</a> &amp;&#160;</td>
          <td class="paramname"><em>ret</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get a specific property. </p>

</div>
</div>
<a class="anchor" id="ad721cb91fe855ddcba36b078cabad4ce"></a><!-- doxytag: member="iPcRules::GetPropertyBool" ref="ad721cb91fe855ddcba36b078cabad4ce" args="(const char *name)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="structiPcRules.html#ad721cb91fe855ddcba36b078cabad4ce">iPcRules::GetPropertyBool</a> </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>name</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get a specific property. </p>

</div>
</div>
<a class="anchor" id="ac489e0149af2f0e8e4cd03f919011861"></a><!-- doxytag: member="iPcRules::GetPropertyColor" ref="ac489e0149af2f0e8e4cd03f919011861" args="(const char *name, csColor &amp;v)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="structiPcRules.html#ac489e0149af2f0e8e4cd03f919011861">iPcRules::GetPropertyColor</a> </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>name</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsColor.html">csColor</a> &amp;&#160;</td>
          <td class="paramname"><em>v</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get a specific property. </p>

</div>
</div>
<a class="anchor" id="a79059bc158ff5168925f8b377af1aec0"></a><!-- doxytag: member="iPcRules::GetPropertyFloat" ref="a79059bc158ff5168925f8b377af1aec0" args="(const char *name)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual float <a class="el" href="structiPcRules.html#a79059bc158ff5168925f8b377af1aec0">iPcRules::GetPropertyFloat</a> </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>name</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get a specific property. </p>

</div>
</div>
<a class="anchor" id="a8ced2bfc1d61946e47018d99b6bd203a"></a><!-- doxytag: member="iPcRules::GetPropertyLong" ref="a8ced2bfc1d61946e47018d99b6bd203a" args="(const char *name)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual long <a class="el" href="structiPcRules.html#a8ced2bfc1d61946e47018d99b6bd203a">iPcRules::GetPropertyLong</a> </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>name</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get a specific property. </p>

</div>
</div>
<a class="anchor" id="ae3b6571de348bcebdb9a394dc735b774"></a><!-- doxytag: member="iPcRules::GetPropertyString" ref="ae3b6571de348bcebdb9a394dc735b774" args="(const char *name)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual const char* <a class="el" href="structiPcRules.html#ae3b6571de348bcebdb9a394dc735b774">iPcRules::GetPropertyString</a> </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>name</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get a specific property. </p>

</div>
</div>
<a class="anchor" id="a91217faf3dfd5936df82f32eb1c5eb0d"></a><!-- doxytag: member="iPcRules::GetPropertyType" ref="a91217faf3dfd5936df82f32eb1c5eb0d" args="(const char *name)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual celDataType <a class="el" href="structiPcRules.html#a91217faf3dfd5936df82f32eb1c5eb0d">iPcRules::GetPropertyType</a> </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>name</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get the type of the property. </p>
<p>This will base itself on the underlying pcproperties. If there is no pcproperties class with the right property in it then this will return CEL_DATA_NONE even though getting a specific typed value might work. </p>

</div>
</div>
<a class="anchor" id="a90c63a8378b8dd3bd6274ad03f7ffd90"></a><!-- doxytag: member="iPcRules::GetPropertyVector" ref="a90c63a8378b8dd3bd6274ad03f7ffd90" args="(const char *name, csVector2 &amp;v)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="structiPcRules.html#a90c63a8378b8dd3bd6274ad03f7ffd90">iPcRules::GetPropertyVector</a> </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>name</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector2.html">csVector2</a> &amp;&#160;</td>
          <td class="paramname"><em>v</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get a specific property. </p>

</div>
</div>
<a class="anchor" id="ab5ca106e2739e8593f8764f7a877e323"></a><!-- doxytag: member="iPcRules::GetPropertyVector" ref="ab5ca106e2739e8593f8764f7a877e323" args="(const char *name, csVector3 &amp;v)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="structiPcRules.html#a90c63a8378b8dd3bd6274ad03f7ffd90">iPcRules::GetPropertyVector</a> </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>name</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a> &amp;&#160;</td>
          <td class="paramname"><em>v</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get a specific property. </p>

</div>
</div>
<hr/>The documentation for this struct was generated from the following file:<ul>
<li>propclass/<a class="el" href="rules_8h_source.html">rules.h</a></li>
</ul>
</div><!-- contents -->
<hr size="1"><address><small>Generated for CEL: Crystal Entity Layer 2.0 by 
<a href="http://www.doxygen.org/index.html">doxygen</a> 1.7.6.1 
</small></address> </div></body> </html>
